#include "dmul_target.hpp"

void
T1::dispatch_m(C1 *C1_o)
{
  C1_o->m(this);
}

void
T1::dispatch_m(C2 *C2_o)
{
  C2_o->m(this);
}

void
T1::dispatch_m(C3 *C3_o)
{
  C3_o->m(this);
}

void
T2::dispatch_m(C2 *C2_o)
{
  C2_o->m(this);
}

void
T2::dispatch_m(C3 *C3_o)
{
  C3_o->m(this);
}

void
T3::dispatch_m(C3 *C3_o)
{
  C3_o->m(this);
}

void
#line 36 "dmul_target.h"
C1::m(T1 * t)
#line 36 "dmul_target.h"
{ cout << "C1::m(T1)" << endl; }

void
C1::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
#line 46 "dmul_target.h"
C2::m(T2 * t)
#line 46 "dmul_target.h"
{ cout << "C2::m(T2)" << endl; }

void
C2::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
C2::m_DB(T2 * t)
{
  t->dispatch_m(this);
}

void
#line 54 "dmul_target.h"
C3::m(T3 * t)
#line 54 "dmul_target.h"
{ cout << "C3::m(T3)" << endl; }

void
C3::m_DB(T1 * t)
{
  t->dispatch_m(this);
}

void
C3::m_DB(T2 * t)
{
  t->dispatch_m(this);
}

void
C3::m_DB(T3 * t)
{
  t->dispatch_m(this);
}

