#include "non_virtual.hpp"

void
T1::dispatch_m(Base *Base_o)
{
  Base_o->m(this);
}

void
T1::dispatch_m(Deriv *Deriv_o)
{
  Deriv_o->m(this);
}

void
T1::dispatch_n(Base *Base_o)
{
  Base_o->n(this);
}

void
T1::dispatch_n(Deriv *Deriv_o)
{
  Deriv_o->n(this);
}

void
T2::dispatch_m(Deriv *Deriv_o)
{
  Deriv_o->m(this);
}

void
T2::dispatch_n(Deriv *Deriv_o)
{
  Deriv_o->n(this);
}

void
T3::dispatch_m(Base *Base_o)
{
  Base_o->m(this);
}

void
T3::dispatch_m(Deriv *Deriv_o)
{
  Deriv_o->m(this);
}

void
T3::dispatch_n(Base *Base_o)
{
  Base_o->n(this);
}

void
T3::dispatch_n(Deriv *Deriv_o)
{
  Deriv_o->n(this);
}

void
T4::dispatch_m(Deriv *Deriv_o)
{
  Deriv_o->m(this);
}

void
T4::dispatch_n(Deriv *Deriv_o)
{
  Deriv_o->n(this);
}

void
#line 28 "non_virtual.h"
Base::m(T1 * _param1)
#line 28 "non_virtual.h"
{ cout << "Base::m(T1)" << endl; }

void
#line 29 "non_virtual.h"
Base::m(T3 * _param1)
#line 29 "non_virtual.h"
{ cout << "Base::m(T3)" << endl; }

void
Base::m_DB(T1 * _param1)
{
  _param1->dispatch_m(this);
}

void
#line 33 "non_virtual.h"
Base::n(T1 * _param1)
#line 33 "non_virtual.h"
{ cout << "Base::n(T1)" << endl; }

void
#line 34 "non_virtual.h"
Base::n(T3 * _param1)
#line 34 "non_virtual.h"
{ cout << "Base::n(T3)" << endl; }

void
Base::n_DB(T1 * _param1)
{
  _param1->dispatch_n(this);
}

void
#line 44 "non_virtual.h"
Deriv::m(T2 * _param1)
#line 44 "non_virtual.h"
{ cout << "Deriv::m(T2)" << endl; }

void
#line 45 "non_virtual.h"
Deriv::m(T4 * _param1)
#line 45 "non_virtual.h"
{ cout << "Deriv::m(T4)" << endl; }

void
Deriv::m_DB(T1 * _param1)
{
  _param1->dispatch_m(this);
}

void
#line 49 "non_virtual.h"
Deriv::n(T2 * _param1)
#line 49 "non_virtual.h"
{ cout << "Deriv::n(T2)" << endl; }

void
#line 50 "non_virtual.h"
Deriv::n(T4 * _param1)
#line 50 "non_virtual.h"
{ cout << "Deriv::n(T4)" << endl; }

void
Deriv::n_DB(T1 * _param1)
{
  _param1->dispatch_n(this);
}

