/*
  This example uses two different hierarchies Bx and Cx that
  define branches for the same hierarchy Ox
*/

int
main()
{
  B1 *b = new B2;

  b->m_DB(new O1_d);
  b->m_DB(new O2);
  b->m_DB(new O3);
  b->m_DB(new O4);

  std::cout << std::endl;

  O1_d *t;
  t = new O1_d;
  b->m_DB(t);
  t = new O2;
  b->m_DB(t);
  t = new O3;
  b->m_DB(t);
  t = new O4;
  b->m_DB(t);

  std::cout << std::endl;

  C1 *c = new C2;

  c->m_DB(new O1_d);
  c->m_DB(new O2);
  c->m_DB(new O3);
  c->m_DB(new O4);

  std::cout << std::endl;

  t = new O1_d;
  c->m_DB(t);
  t = new O2;
  c->m_DB(t);
  t = new O3;
  c->m_DB(t);
  t = new O4;
  c->m_DB(t);

  return 0;
}
