/*
  the multimethod defined here has to do with two different hierarchies
  but refers to the same method name
*/

#ifndef TWOBASES2_H
#define TWOBASES2_H

#include "twobases.hpp"

class TwoBases2 : public TwoBases
{
 public:
  virtual branch m
  virtual void (FirstT2 *t) {
    cout << "TwoBases2::m(FirstT2)" << endl;
  };
  virtual void (FirstT1 *t, long l) {
    cout << "TwoBases2::m(FirstT1, long)" << endl;
  };
  virtual void (SecondT1 *t) {
    cout << "TwoBases2::m(SecondT1)" << endl;
  };
  virtual void (SecondT2 *t) {
    cout << "TwoBases2::m(SecondT2)" << endl;
  };
  endbranch
};

#endif // TWOBASES2_H
