/***************************************************************************
 *   Copyright (C) 2003 by Lorenzo Bettini                                 *
 *   http://www.lorenzobettini.it                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

// defines an order among classes of the same hierarchy according to
// inheritance, in reverse order

#ifndef CLASSLESS_H
#define CLASSLESS_H

#include "classdecl.h"

struct Class_less
{
  bool operator() (const ClassDecl *c1, const ClassDecl *c2) const
  { return c1->isSubClass(c2, false); }
};

#endif // CLASSLESS_H
