#include "includeheader.h"

#include "forwarddecls.h"

#include "withmethdecls.h"

#include "classend.h"

#include "multimethod.h"

#include "classdecl.h"

#include "progelem.h"

#include "progelems.hpp"

void
#line 64 "./progelems.h"
ProgElems::intern_add_item(ProgElem * p)
#line 65 "./progelems.h"
{
      // do nothing
    }

void
#line 68 "./progelems.h"
ProgElems::intern_add_item(ClassDecl * c)
#line 69 "./progelems.h"
{
      add_class_decl (c);
    }

void
#line 72 "./progelems.h"
ProgElems::intern_add_item(MultiMethod * b)
#line 73 "./progelems.h"
{
      add_multimethod (b);
    }

void
#line 76 "./progelems.h"
ProgElems::intern_add_item(ClassEnd * c)
#line 77 "./progelems.h"
{
      add_classend (c);
    }

void
#line 80 "./progelems.h"
ProgElems::intern_add_item(WithMethDecls * w)
#line 81 "./progelems.h"
{
      generated_meth_list.push_back (w);
    }

void
#line 84 "./progelems.h"
ProgElems::intern_add_item(ForwardDecls * forw)
#line 85 "./progelems.h"
{
      forwarddecls.addFrom (forw);
    }

void
#line 88 "./progelems.h"
ProgElems::intern_add_item(IncludeHeader * i)
#line 89 "./progelems.h"
{
      add_include (i);
    }

void
ProgElems::intern_add_item_DB(ProgElem * p)
{
  p->dispatch_intern_add_item(this);
}

void
ClassDecl::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
ClassEnd::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
ForwardDecls::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
IncludeHeader::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
MultiMethod::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
ProgElem::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

void
WithMethDecls::dispatch_intern_add_item(ProgElems *ProgElems_o)
{
  ProgElems_o->_forward_intern_add_item(this);
}

