#include "const_testmod.hh"

void
#line 20 "const_test.hhh"
BaseConst::m(T1 * t)
#line 20 "const_test.hhh"
{ cout << "BaseConst::m(T1)" << endl; }

void
#line 21 "const_test.hhh"
BaseConst::m(T2 * t)
#line 21 "const_test.hhh"
{ cout << "BaseConst::m(T2)" << endl; }

void
#line 22 "const_test.hhh"
BaseConst::m(const T1 * t)
#line 22 "const_test.hhh"
{ cout << "BaseConst::m(const T1)" << endl; }

void
#line 23 "const_test.hhh"
BaseConst::m(const T2 * t)
#line 23 "const_test.hhh"
{ cout << "BaseConst::m(const T2)" << endl; }

void
BaseConst::m_DB(T1 * t)
{
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

void
BaseConst::m_DB(const T1 * t)
{
  if (const T2 * _t = dynamic_cast<const T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

void
#line 33 "const_test.hhh"
DerivConst::m(T2 * t)
#line 33 "const_test.hhh"
{ cout << "DerivConst::m(T2)" << endl; }

void
#line 34 "const_test.hhh"
DerivConst::m(T3 * t)
#line 34 "const_test.hhh"
{ cout << "DerivConst::m(T3)" << endl; }

void
#line 35 "const_test.hhh"
DerivConst::m(const T2 * t)
#line 35 "const_test.hhh"
{ cout << "DerivConst::m(const T2)" << endl; }

void
#line 36 "const_test.hhh"
DerivConst::m(const T3 * t)
#line 36 "const_test.hhh"
{ cout << "DerivConst::m(const T3)" << endl; }

void
DerivConst::m_DB(T1 * t)
{
  if (T3 * _t = dynamic_cast<T3 *>(t)) {
    m ( _t );
    return;
  }
  
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

void
DerivConst::m_DB(const T1 * t)
{
  if (const T3 * _t = dynamic_cast<const T3 *>(t)) {
    m ( _t );
    return;
  }
  
  if (const T2 * _t = dynamic_cast<const T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

