// a subclass introduces a branch with a supertype w.r.t. the superclass

#ifndef CONTRA_SPEC_H
#define CONTRA_SPEC_H

#include <iostream>

using std::cout;
using std::endl;

class T1 {
 public:
  virtual void foo() {}

  virtual ~T1() {}
};

class T2 : public T1 {};

class T3 : public T2 {};

class Contra_Base
{
 protected:
  virtual branch m
  virtual void (T2 *t) { cout << "Contra_Base::m(T2)" << endl; };
  virtual void (T3 *t) { cout << "Contra_Base::m(T3)" << endl; };
  endbranch

  virtual ~Contra_Base() {}
};

class Contra_Spec : public Contra_Base
{
 public:
  virtual branch m
  virtual void (T1 *t) { cout << "Contra_Spec::m(T1)" << endl; };
  endbranch
};

#endif // CONTRA_SPEC_H
