// a subclass introduces a branch with a supertype w.r.t. the superclass
// however, in the superclass the method is private

#ifndef CONTRA_SPEC_H
#define CONTRA_SPEC_H

#include <iostream>

using std::cout;
using std::endl;

class T1 
{ 
 public:
  virtual ~T1() {}

  virtual void foo() {} 
};

class T2 : public T1 {};

class T3 : public T2 {};

class Contra_Base
{
  branch m
  void (T2 *t) { cout << "Contra_Base::m(T2)" << endl; };
  void (T3 *t) { cout << "Contra_Base::m(T3)" << endl; };
  endbranch

public:
  void my_pub(T2 *t)
  {
    m_DB(t);
  }
};

class Contra_Spec : public Contra_Base
{
 public:
  branch m
  void (T1 *t) { cout << "Contra_Spec::m(T1)" << endl; };
  endbranch
};

#endif // CONTRA_SPEC_H
