// only redefine without adding any new specialization

#ifndef D2_H
#define D2_H

#include <iostream>

using std::cout;
using std::endl;

class T2_Mul1
{
 public:
  virtual void foo() {}
  virtual ~T2_Mul1() {}
};

class T2_Mul2 : public T2_Mul1
{
  void foo2() {}
};

class T2_Mul3 : public T2_Mul2
{
  void foo3() {}
};

class B2_Mul2
{
 public:
  virtual branch m
    virtual void (T2_Mul1 *t)   { cout << "B_Mul2::m(T_Mul1 *)" << endl; };
    virtual void (T2_Mul3 *t)   { cout << "B_Mul2::m(T_Mul3 *)" << endl; };
  endbranch

    virtual ~B2_Mul2() {}
};

class B2_Mul1
{
 public:
  virtual branch m
    virtual void (T2_Mul2 *t)   { cout << "B_Mul1::m(T_Mul2 *)" << endl; };
  endbranch

    virtual ~B2_Mul1() {}
};

class D2_Mul : public B2_Mul1, public B2_Mul2
{
 public:
  virtual branch m
    virtual void (T2_Mul1 *t)   { cout << "D_Mul::m(T_Mul1 *)" << endl; };
    virtual void (T2_Mul2 *t)   { cout << "D_Mul::m(T_Mul2 *)" << endl; };
  endbranch
};

#endif
