#include "d_mul_same_meth.hpp"

void
TSame1::dispatch_foo(BSame1 *BSame1_o)
{
  BSame1_o->foo_(this);
}

void
TSame1::dispatch_foo(BSame2 *BSame2_o)
{
  BSame2_o->foo_(this);
}

void
TSame1::dispatch_foo(DSame *DSame_o)
{
  DSame_o->foo_(this);
}

void
TSame1::dispatch_m(BSame1 *BSame1_o)
{
  BSame1_o->m_(this);
}

void
TSame1::dispatch_m(BSame2 *BSame2_o)
{
  BSame2_o->m_(this);
}

void
TSame1::dispatch_m(DSame *DSame_o)
{
  DSame_o->m_(this);
}

void
TSame2::dispatch_m(DSame *DSame_o)
{
  DSame_o->m_(this);
}

void
#line 31 "./d_mul_same_meth.h"
BSame1::m_(TSame1 * t)
#line 32 "./d_mul_same_meth.h"
{ cout << "BSame1::m(TSame1)" << endl; }

void
BSame1::m(TSame1 * t)
{
  t->dispatch_m(this);
}

void
#line 36 "./d_mul_same_meth.h"
BSame1::foo_(TSame1 * t)
#line 37 "./d_mul_same_meth.h"
{ cout << "BSame1::foo(TSame1)" << endl; }

void
BSame1::foo(TSame1 * t)
{
  t->dispatch_foo(this);
}

void
#line 47 "./d_mul_same_meth.h"
BSame2::m_(TSame1 * t)
#line 48 "./d_mul_same_meth.h"
{ cout << "BSame2::m(TSame1)" << endl; }

void
BSame2::m(TSame1 * t)
{
  t->dispatch_m(this);
}

void
#line 52 "./d_mul_same_meth.h"
BSame2::foo_(TSame1 * t)
#line 53 "./d_mul_same_meth.h"
{ cout << "BSame2::foo(TSame1)" << endl; }

void
BSame2::foo(TSame1 * t)
{
  t->dispatch_foo(this);
}

void
#line 65 "./d_mul_same_meth.h"
DSame::m_(TSame1 * t)
#line 66 "./d_mul_same_meth.h"
{ 
      cout << "DSame::m(TSame1)" << endl;
      cout << "  "; BSame1::m_ (t);
      cout << "  "; BSame2::m_ (t);
    }

void
#line 71 "./d_mul_same_meth.h"
DSame::m_(TSame2 * t)
#line 72 "./d_mul_same_meth.h"
{ 
      cout << "DSame::m(TSame2)" << endl; 
      cout << "  "; BSame1::m_ (t);
      cout << "  "; BSame2::m_ (t);
      cout << "  "; BSame1::foo_ (t);
    }

void
DSame::m(TSame1 * t)
{
  t->dispatch_m(this);
}

void
#line 81 "./d_mul_same_meth.h"
DSame::foo_(TSame1 * t)
#line 82 "./d_mul_same_meth.h"
{ cout << "DSame::foo(TSame1)" << endl; }

void
DSame::foo(TSame1 * t)
{
  t->dispatch_foo(this);
}

