#include "deriv2_protectedmod.hh"

void
#line 54 "deriv2_protected.hhh"
Base1::m(T1 * t)
#line 54 "deriv2_protected.hhh"
{ std::cout << "Base1::m(T1)" << std::endl; }

void
#line 55 "deriv2_protected.hhh"
Base1::m(T2 * t)
#line 55 "deriv2_protected.hhh"
{ 
    // comment line
    std::cout << "Base1::m(T2)" << std::endl;
  }

void
Base1::m_DB(T1 * t)
{
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

void
#line 62 "deriv2_protected.hhh"
Base1::n(T1 * t)
#line 62 "deriv2_protected.hhh"
{ std::cout << "Base1::n(T1)" << std::endl; }

void
#line 63 "deriv2_protected.hhh"
Base1::n(T2 * t)
#line 63 "deriv2_protected.hhh"
{ 
    // comment line
    std::cout << "Base1::n(T2)" << std::endl;
  }

void
#line 68 "deriv2_protected.hhh"
Base1::n(T1 * t, int i)
#line 68 "deriv2_protected.hhh"
{ std::cout << "Base1::n(T1,i)" << std::endl; }

void
#line 69 "deriv2_protected.hhh"
Base1::n(T2 * t, int i)
#line 69 "deriv2_protected.hhh"
{ 
    // comment line
    std::cout << "Base1::n(T2,i)" << std::endl;
  }

void
Base1::n_DB(T1 * t)
{
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    n ( _t );
    return;
  }
  
  n(t);

}

void
Base1::n_DB(T1 * t, int i)
{
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    n ( _t , i);
    return;
  }
  
  n(t, i);

}

void
Deriv1::m_DB(T1 * tt)
{
  if (T3 * _tt = dynamic_cast<T3 *>(tt)) {
    m ( _tt );
    return;
  }
  
  if (T2 * _tt = dynamic_cast<T2 *>(tt)) {
    m ( _tt );
    return;
  }
  
  m(tt);

}

void
#line 93 "deriv2_protected.hhh"
Deriv1::n(T1 * tt)
#line 93 "deriv2_protected.hhh"
{ std::cout << "Deriv1::n(T1)" << std::endl; }

void
#line 94 "deriv2_protected.hhh"
Deriv1::n(T3 * t, int i)
#line 94 "deriv2_protected.hhh"
{ std::cout << "Deriv1::n(T3,i)" << std::endl; }

void
Deriv1::n_DB(T1 * tt)
{
  if (T2 * _tt = dynamic_cast<T2 *>(tt)) {
    n ( _tt );
    return;
  }
  
  n(tt);

}

void
Deriv1::n_DB(T1 * t, int i)
{
  if (T3 * _t = dynamic_cast<T3 *>(t)) {
    n ( _t , i);
    return;
  }
  
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    n ( _t , i);
    return;
  }
  
  n(t, i);

}

void
#line 107 "deriv2_protected.hhh"
Deriv2::m(T4 * t)
#line 107 "deriv2_protected.hhh"
{ std::cout << "Deriv2::m(T4)" << std::endl; }

void
Deriv2::m_DB(T1 * tt)
{
  if (T4 * _tt = dynamic_cast<T4 *>(tt)) {
    m ( _tt );
    return;
  }
  
  if (T3 * _tt = dynamic_cast<T3 *>(tt)) {
    m ( _tt );
    return;
  }
  
  if (T2 * _tt = dynamic_cast<T2 *>(tt)) {
    m ( _tt );
    return;
  }
  
  m(tt);

}

void
#line 111 "deriv2_protected.hhh"
Deriv2::n(T4 * t, int i)
#line 111 "deriv2_protected.hhh"
{ std::cout << "Deriv2::n(T4,i)" << std::endl; }

void
Deriv2::n_DB(T1 * t, int i)
{
  if (T4 * _t = dynamic_cast<T4 *>(t)) {
    n ( _t , i);
    return;
  }
  
  if (T3 * _t = dynamic_cast<T3 *>(t)) {
    n ( _t , i);
    return;
  }
  
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    n ( _t , i);
    return;
  }
  
  n(t, i);

}

void
#line 120 "deriv2_protected.hhh"
Deriv1_b::m(T3 * t)
#line 120 "deriv2_protected.hhh"
{ std::cout << "Deriv2_b::m(T3)" << std::endl; }

void
Deriv1_b::m_DB(T1 * t)
{
  if (T3 * _t = dynamic_cast<T3 *>(t)) {
    m ( _t );
    return;
  }
  
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

void
#line 128 "deriv2_protected.hhh"
Deriv2_b::m(T4 * t)
#line 128 "deriv2_protected.hhh"
{ std::cout << "Deriv2_b::m(T4)" << std::endl; }

void
Deriv2_b::m_DB(T1 * t)
{
  if (T4 * _t = dynamic_cast<T4 *>(t)) {
    m ( _t );
    return;
  }
  
  if (T3 * _t = dynamic_cast<T3 *>(t)) {
    m ( _t );
    return;
  }
  
  if (T2 * _t = dynamic_cast<T2 *>(t)) {
    m ( _t );
    return;
  }
  
  m(t);

}

