/*
  the multimethod defined here has to do with two different hierarchies
  but refers to the same method name
*/

#ifndef TWOBASES_H
#define TWOBASES_H

#include <iostream>

using std::cout;
using std::endl;

class TwoBases
{
 public:
  virtual ~TwoBases() {}

  virtual branch m
  virtual void (FirstT1 *t) {
    cout << "TwoBases::m(FirstT1)" << endl;
  };
  virtual void (FirstT1 *t, int i) {
    cout << "TwoBases::m(FirstT1, int)" << endl;
  };
  virtual void (FirstT1 *t, long l) {
    cout << "TwoBases::m(FirstT1, long)" << endl;
  };
  virtual void (FirstT1 *t, FirstT1 *t2) {
    cout << "TwoBases::m(FirstT1, FirstT1)" << endl;
  };
  virtual void (FirstT1 *t, FirstT2 *t2) {
    cout << "TwoBases::m(FirstT1, FirstT2)" << endl;
  };
  virtual void (FirstT2 *t, FirstT1 *t2) {
    cout << "TwoBases::m(FirstT2, FirstT1)" << endl;
  };
  virtual void (FirstT2 *t, FirstT2 *t2) {
    cout << "TwoBases::m(FirstT2, FirstT2)" << endl;
  };
  virtual void (SecondT1 *t) {
    cout << "TwoBases::m(SecondT1)" << endl;
  };
  endbranch
};

#endif // TWOBASES_H
